(* Simple Generic Prover Interface *)
(* Author: Frank Pfenning *)

signature PROVER =
sig

  datatype Reason =
    NoProof				(* no proof exists *)
  | Bound				(* bound exceeded *)

  datatype Result =
    Success of int			(* level at which found *)
  | Failure of Reason			(* no proof exists *)

  (* prove (bound, G, A) = result *)
  val prove : int * P.Prop C.Ctx * P.Prop -> Result

end;  (* signature PROVER *)
